//		GetPass 7.1 - C_FILTER for F6FBB BBS Software
// 	Written by Marco Savegnago IW3FQG

#include "gpmsg.h"
#include "strhlp.h"

#include <stdio.h>
#include <fstream.h>

// Message methode

// Standard constructor

TString::TString( const char * cpsz_msg )
{
	i_lenOfString = strlen( cpsz_msg );
	psz_string = new char[ i_lenOfString + 1 ];
	strcpy( psz_string , cpsz_msg );
}

TString::~TString()
{
	delete [] psz_string;
    i_lenOfString = 0;
}

char *TString::setString(const char * psz_str)
{
	register char * pc_temp;

	i_lenOfString = strlen( psz_str );
	pc_temp = new char[ i_lenOfString + 1 ];
	strcpy( pc_temp, psz_str );
	delete[] psz_string;
	psz_string = pc_temp;

	return psz_string;
}

char * TString::add( const char *psz_str)
{
	register char * pc_temp;

	i_lenOfString += strlen( psz_str );
	pc_temp = new char[ i_lenOfString + 1 ];
	strcpy( pc_temp, psz_string );
	strcat( pc_temp, psz_str );
	delete[] psz_string;
	psz_string = pc_temp;

	return psz_string;
}

char *TString::isStringInc(char *psz_str)
{
	int len=strlen(psz_str);

	for(char *p=psz_string;*p;p++)
		if(!strnicmp(psz_str,p,len))
						return(p);

	return(NULL);
}

Message::Message()
:
	i_messageNum(0)
{
	i_lenOfString = 0;
	psz_string = NULL;
}

Message::Message( int num, const char * cpsz_msg )
:
	TString ( cpsz_msg ),
	i_messageNum(num)
{
}


PasswordString::PasswordString (char *pwd)
:
	TString (pwd)
{
	strip_crlf ( psz_string );
	psz_password = new char[ i_lenOfString + 1 ];
	setPasswordLenght();
}

char *PasswordString::setPasswordString(const char * psz_str)
{
	setString(psz_str);
	strip_crlf ( psz_string );
	i_lenOfString = strlen( psz_str );
	char* pc_temp = new char[ strlen( psz_str ) + 1 ];
	strcpy( pc_temp, psz_str );
	delete[] psz_password;
	psz_password = pc_temp;
	setPasswordLenght();

	return psz_password;
}

void PasswordString::setPasswordLenght()
{
	char *p=psz_string;
	i_lenOfPasswordString=0;

	while (*p)
	{
		switch (*p)
		{
			case '(':
				while ( *p++ != ')' )
				;
				i_lenOfPasswordString++;
				break;
			case '"':
				p+=2;
				i_lenOfPasswordString++;
				break;
			default:
				p++;
				i_lenOfPasswordString++;
				break;

		}
	}
}

char * PasswordString::getPos ( int pos )
{
	strcpy( psz_password, psz_string );

	register int i=0;

	char *p=psz_password;

	while (i < pos && *p)
	{
		switch (*p)
		{
			case '(':
				while ( *p++ != ')' )
				;
				i++;
				break;
			case '"':
				p++;
			default:
				p++;
				i++;
				break;
		}
	}

	char *t=p;

	switch (*t)
	{
		case '(':
			while ( *t++ != ')' )
			;
			break;
		case '"':
			t++;
		default:
			t++;
			break;
	}

	*t=EOS;


	return (p);
}

// MessageVect methode

MessageVect::MessageVect( int item )
{
	i_lenOfMessageVect = item;
	theMessageVect = new Message *[ item ];
	for ( register int i = 0; i < item; i++ )
			theMessageVect[ i ] = NULL;
}


MessageVect::~MessageVect()
{
	for( register int i = 0; i < i_lenOfMessageVect; i++ )
				if( theMessageVect[ i ] != NULL )
					delete( theMessageVect[ i ] );
	delete[] theMessageVect;
}

MessageFile::MessageFile( const char*	psz_filename, int numslot )
:
	MessageVect( numslot )
{
	strncpy(sz_fname, psz_filename, sizeof(sz_fname));
}

int MessageFile::readFile()
{
	int nummessage = 0;
	char sz_temp[ MAXLINELEN ];

#ifdef __DEBUG__
	{
		ofstream	clog("C_FILTER.LOG", ios::out|ios::app);
		clog	<< "TRACK1.2.1" << endl;
		clog.close();
	}
#endif

	ifstream msg_file ( sz_fname );

#ifdef __DEBUG__
	{
		ofstream	clog("C_FILTER.LOG", ios::out|ios::app);
		clog	<< "TRACK1.2.2" << endl;
		clog.close();
	}
#endif

	if ( ! msg_file.good() )
	{
#ifdef __DEBUG__
		cerr << "DEBUG: I/O Error opening file " << sz_fname << endl;
#endif
		return( 1 );
	}

#ifdef __DEBUG__
	{
		ofstream	clog("C_FILTER.LOG", ios::out|ios::app);
		clog	<< "TRACK1.2.3" << endl;
		clog.close();
	}
#endif

	while ( msg_file.getline ( sz_temp, sizeof (sz_temp) ) , ! msg_file.eof() )
	{

#ifdef __DEBUG__
      {
         ofstream	clog("C_FILTER.LOG", ios::out|ios::app);
         clog	<< "TRACK1.2.4n" << endl;
         clog.close();
      }
#endif

		register char * p = sz_temp;

		if(isComment(p))
					continue;

		skipSpace(p);

		if(isComment(p) || *p == EOS)
					continue;

		if ( ':' == * p)     // found!
		{
			while( ! isdigit( * p ) )
									p++;

			int messagenum;

			if( ( messagenum = atoi( p ) ) > i_lenOfMessageVect - 1 )
				break;

			nummessage++;

			bool b_endmsg = false;

			Message * message = new Message( messagenum );

			do
			{
				if ( msg_file.getline ( sz_temp, sizeof sz_temp ), msg_file.fail() )
					break;

				p = sz_temp;

				if( strlen( p ) <= 2 )
				{
					switch( * p )
					{
						case '!':
						case ';':
							continue;
						case '/':
							if ( *(p+1) == '/')
								continue;

							*message + sz_temp;
							break;

						case '%':
							if ( *( p + 1 ) == '%' )   // skip escape
								*message + sz_temp;

							*message + "\n" ;
							break;

						case '\0':
							b_endmsg = true;
							break;

						default:
							*message + sz_temp + "\n";
							break;
					}
				}
				else
					*message + sz_temp + "\n";
			}
			  while( b_endmsg == false );

			  add( message );
		 }
	 }

	 msg_file.close();	// dummy because the destructor is automatically
						// called when msg_file exit form its scope

	 return ( nummessage != i_lenOfMessageVect );
}


// ConfigFile methode

bool	ConfigFile::getBoolParam( int i_slot )
{
	switch( toupper( * getMessage( i_slot ) ) )
	{
		case 'Y':
		case 'S':
		case '1':
        case NULL:	// Default True;
			return true;
		default:
			return false;
	}
}
